﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;

namespace FlexGrid_DragDrop
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            c1Schedule1.AllowDrop = true;
            c1Schedule1.DragDrop += new DragEventHandler(c1Schedule1_DragDrop);

            #region 初始化FlexGrid
            
            // 使用 FlexGrid 内置的拖拽方式
            c1FlexGrid1.DragMode = DragModeEnum.AutomaticCopy;

            c1FlexGrid1.Cols.Fixed = 0;            
            c1FlexGrid1.Rows.Count = 1;
            c1FlexGrid1.Cols.Count = 1;
            c1FlexGrid1.ExtendLastCol = true;
            c1FlexGrid1.Styles.Normal.TextAlign = TextAlignEnum.LeftCenter;
            c1FlexGrid1.Styles.Normal.Border.Style = BorderStyleEnum.None;
            
            c1FlexGrid1.Tree.Column = 0;
            c1FlexGrid1.Tree.Style = TreeStyleFlags.SimpleLeaf;
            c1FlexGrid1.Tree.LineColor = Color.DarkBlue;

            BuildTree();

            #endregion

        }

        void c1Schedule1_DragDrop(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(C1.C1Schedule.Appointment)))
            {
                // 获取拖拽到 Schedule 上的 Appointment 对象
                C1.C1Schedule.Appointment app = e.Data.GetData(typeof(C1.C1Schedule.Appointment)) as C1.C1Schedule.Appointment;

                // 设置 Appointment 的任意属性
                app.Subject = app.Body;                
                app.Body = "测试任务";
            }
        }

        private void BuildTree()
        {
            CellStyle cs = c1FlexGrid1.Styles.Add("Node");
            cs.Font = new System.Drawing.Font("微软雅黑", 10);
            cs.ForeColor = Color.DarkBlue;

            c1FlexGrid1.AddItem("西安葡萄城控件");
            Row row = c1FlexGrid1.Rows[c1FlexGrid1.Rows.Count - 1];
            row.IsNode = true;
            row.Style = c1FlexGrid1.Styles["Node"];

            Node nd = row.Node;
            nd.Level = 0;
            nd.Image = Image.FromFile("1.png");
            c1FlexGrid1.AddItem("产品部");
            row = c1FlexGrid1.Rows[c1FlexGrid1.Rows.Count - 1];
            row.IsNode = true;
            row.Style = c1FlexGrid1.Styles["Node"];
            nd = row.Node;
            nd.Level = 1;
            nd.Image = Image.FromFile("2.png");

            c1FlexGrid1.AddItem("ComponentOne 产品部");
            c1FlexGrid1.AddItem("Spread 产品部");
            c1FlexGrid1.AddItem("ActiveReports 产品部");
            c1FlexGrid1.AddItem("TX TextControl 产品部");

            c1FlexGrid1.AddItem("市场部");
            row = c1FlexGrid1.Rows[c1FlexGrid1.Rows.Count - 1];
            row.IsNode = true;
            row.Style = c1FlexGrid1.Styles["Node"];
            nd = row.Node;
            nd.Level = 1;
            nd.Image = Image.FromFile("2.png");

            c1FlexGrid1.AddItem("ComponentOne 市场部");
            c1FlexGrid1.AddItem("Spread 市场部");
            c1FlexGrid1.AddItem("ActiveReports 市场部");
            c1FlexGrid1.AddItem("TX TextControl 市场部");

            c1FlexGrid1.AddItem("销售部");
            row = c1FlexGrid1.Rows[c1FlexGrid1.Rows.Count - 1];
            row.IsNode = true;
            row.Style = c1FlexGrid1.Styles["Node"];
            nd = row.Node;
            nd.Level = 1;
            nd.Image = Image.FromFile("2.png");

            c1FlexGrid1.AddItem("ComponentOne 销售部");
            c1FlexGrid1.AddItem("Spread 销售部");
            c1FlexGrid1.AddItem("ActiveReports 销售部");
            c1FlexGrid1.AddItem("TX TextControl 销售部");

            c1FlexGrid1.AddItem("服务部");
            row = c1FlexGrid1.Rows[c1FlexGrid1.Rows.Count - 1];
            row.IsNode = true;
            row.Style = c1FlexGrid1.Styles["Node"];
            nd = row.Node;
            nd.Level = 1;
            nd.Image = Image.FromFile("2.png");

            c1FlexGrid1.AddItem("ComponentOne 服务部");
            c1FlexGrid1.AddItem("Spread 服务部");
            c1FlexGrid1.AddItem("ActiveReports 服务部");
            c1FlexGrid1.AddItem("TX TextControl 服务部");
        }
    }
}
